--- a/poller.php
+++ b/poller.php
@@ -108,6 +108,8 @@
 	pcntl_signal(SIGINT, "sig_handler");
 }
 
+api_plugin_hook('poller_top');
+
 /* record the start time */
 list($micro,$seconds) = explode(" ", microtime());
 $poller_start         = $seconds + $micro;
@@ -303,6 +305,8 @@
 			$total_procs    = $concurrent_processes;
 		}
 
+		$extra_args = api_plugin_hook_function ('poller_command_args', $extra_args);
+
 		/* Populate each execution file with appropriate information */
 		foreach ($polling_hosts as $item) {
 			if ($host_count == 1) {
@@ -446,7 +450,9 @@
 
 		/* sleep the appripriate amount of time */
 		if ($poller_runs_completed < $poller_runs) {
+			api_plugin_hook('poller_bottom');
 			usleep($sleep_time * 1000000);
+			api_plugin_hook('poller_top');
 		}
 	}else if (read_config_option('log_verbosity') >= POLLER_VERBOSITY_MEDIUM || $debug) {
 		cacti_log("WARNING: Cacti Polling Cycle Exceeded Poller Interval by " . $loop_end-$loop_start-$poller_interval . " seconds", TRUE, "POLLER");
@@ -493,4 +499,6 @@
 	echo "    --debug|-d     Output debug information.  Similar to cacti's DEBUG logging level.\n\n";
 }
 
+api_plugin_hook('poller_bottom');
+
 ?>
--- a/data_sources.php
+++ b/data_sources.php
@@ -44,6 +44,8 @@
 	7 => "Disable"
 	);
 
+$ds_actions = api_plugin_hook_function('data_source_action_array', $ds_actions);
+
 /* set default action */
 if (!isset($_REQUEST["action"])) { $_REQUEST["action"] = ""; }
 
@@ -402,6 +404,8 @@
 				api_reapply_suggested_data_source_title($selected_items[$i]);
 				update_data_source_title_cache($selected_items[$i]);
 			}
+		} else { 
+			api_plugin_hook_function('data_source_action_execute', $_POST['drp_action']);
 		}
 		header("Location: data_sources.php");
 		exit;
@@ -545,6 +549,12 @@
 				</tr>\n
 				";
 			$save_html = "<input type='button' value='Cancel' onClick='window.history.back()'>&nbsp;<input type='submit' value='Continue' title='Reapply Suggested Naming to Data Source(s)'>";
+		}else{
+			$save['drp_action'] = $_POST['drp_action'];
+			$save['ds_list'] = $ds_list;
+			$save['ds_array'] = (isset($ds_array)? $ds_array : array());
+			api_plugin_hook_function('data_source_action_prepare', $save);
+			$save_html = "<input type='button' value='Cancel' onClick='window.history.back()'>&nbsp;<input type='submit' value='Continue'>";
 		}
 	}else{
 		print "<tr><td bgcolor='#" . $colors["form_alternate1"]. "'><span class='textError'>You must select at least one data source.</span></td></tr>\n";
@@ -683,6 +693,8 @@
 	input_validate_input_number(get_request_var("host_id"));
 	/* ==================================================== */
 
+	api_plugin_hook('data_source_edit_top');
+
 	$use_data_template = true;
 	$host_id = 0;
 
@@ -975,6 +987,8 @@
 
 	form_save_button("data_sources.php");
 
+	api_plugin_hook('data_source_edit_bottom');
+
 	include_once("./include/bottom_footer.php");
 
 }
@@ -1310,8 +1324,10 @@
 	$i = 0;
 	if (sizeof($data_sources) > 0) {
 		foreach ($data_sources as $data_source) {
+			$data_source["data_template_name"] = htmlspecialchars($data_source["data_template_name"]);
+			$data_source = api_plugin_hook_function('data_sources_table', $data_source);
 			/* we're escaping strings here, so no need to escape them on form_selectable_cell */
-			$data_template_name = ((empty($data_source["data_template_name"])) ? "<em>None</em>" : htmlspecialchars($data_source["data_template_name"]));
+			$data_template_name = ((empty($data_source["data_template_name"])) ? "<em>None</em>" : $data_source["data_template_name"]);
 			$data_input_name    = ((empty($data_source["data_input_name"])) ? "<em>External</em>" : htmlspecialchars($data_source["data_input_name"]));
 			$poller_interval    = ((isset($poller_intervals[$data_source["local_data_id"]])) ? $poller_intervals[$data_source["local_data_id"]] : 0);
 			form_alternate_row_color($colors["alternate"], $colors["light"], $i, 'line' . $data_source["local_data_id"]); $i++;
--- a/cacti.sql
+++ b/cacti.sql
@@ -2639,3 +2639,70 @@
 --
 
 INSERT INTO version VALUES ('new_install');
+
+-- 
+-- Table structure for table `plugin_config`
+-- 
+
+CREATE TABLE `plugin_config` (
+  `id` int(8) NOT NULL auto_increment,
+  `directory` varchar(32) NOT NULL default '',
+  `name` varchar(64) NOT NULL default '',
+  `status` tinyint(2) NOT NULL default '0',
+  `author` varchar(64) NOT NULL default '',
+  `webpage` varchar(255) NOT NULL default '',
+  `version` varchar(8) NOT NULL default '',
+  PRIMARY KEY  (`id`),
+  KEY `status` (`status`),
+  KEY `directory` (`directory`)
+) TYPE=MyISAM;
+
+-- --------------------------------------------------------
+
+-- 
+-- Table structure for table `plugin_hooks`
+-- 
+
+CREATE TABLE `plugin_hooks` (
+  `id` int(8) NOT NULL auto_increment,
+  `name` varchar(32) NOT NULL default '',
+  `hook` varchar(64) NOT NULL default '',
+  `file` varchar(255) NOT NULL default '',
+  `function` varchar(128) NOT NULL default '',
+  `status` int(8) NOT NULL default '0',
+  PRIMARY KEY  (`id`),
+  KEY `hook` (`hook`),
+  KEY `status` (`status`)
+) TYPE=MyISAM;
+
+-- --------------------------------------------------------
+
+-- 
+-- Table structure for table `plugin_realms`
+-- 
+
+CREATE TABLE `plugin_realms` (
+  `id` int(8) NOT NULL auto_increment,
+  `plugin` varchar(32) NOT NULL default '',
+  `file` text NOT NULL,
+  `display` varchar(64) NOT NULL default '',
+  PRIMARY KEY  (`id`),
+  KEY `plugin` (`plugin`)
+) TYPE=MyISAM;
+
+
+CREATE TABLE `plugin_db_changes` (
+  `id` int(10) NOT NULL auto_increment,
+  `plugin` varchar(16) NOT NULL default '',
+  `table` varchar(64) NOT NULL default '',
+  `column` varchar(64) NOT NULL,
+  `method` varchar(16) NOT NULL default '',
+  PRIMARY KEY  (`id`),
+  KEY `plugin` (`plugin`),
+  KEY `method` (`method`)
+) TYPE=MyISAM;
+
+
+REPLACE INTO `plugin_realms` VALUES (1, 'internal', 'plugins.php', 'Plugin Management');
+INSERT INTO `plugin_hooks` VALUES (1, 'internal', 'config_arrays', '', 'plugin_config_arrays', 1);
+INSERT INTO `plugin_hooks` VALUES (2, 'internal', 'draw_navigation_text', '', 'plugin_draw_navigation_text', 1);
